import React from 'react';
import PropTypes from 'prop-types';
import { NextComponentType, IContext, IAppContext, IAppInitialProps, IAppProps } from 'next-server/dist/lib/utils';
import { Router } from 'next/router';
export { NextComponentType, IContext, IAppContext, IAppInitialProps, IAppProps };
export declare type AppClientContext = IAppContext<Router>;
export declare type AppProps = IAppProps<Router>;
export default class App extends React.Component<AppProps> {
    static childContextTypes: {
        router: PropTypes.Requireable<object>;
    };
    static getInitialProps({ Component, ctx }: AppClientContext): Promise<IAppInitialProps>;
    getChildContext(): {
        router: import("../client/router").IPublicRouterInstance;
    };
    componentDidCatch(err: Error): void;
    render(): JSX.Element;
}
export declare class Container extends React.Component {
    componentDidMount(): void;
    componentDidUpdate(): void;
    scrollToHash(): void;
    render(): React.ReactNode;
}
export declare function createUrl(router: Router): {
    readonly query: string;
    readonly pathname: string;
    readonly asPath: string;
    back: () => void;
    push: (url: string, as?: string | undefined) => Promise<boolean>;
    pushTo: (href: string, as?: string | undefined) => Promise<boolean>;
    replace: (url: string, as?: string | undefined) => Promise<boolean>;
    replaceTo: (href: string, as?: string | undefined) => Promise<boolean>;
};
